Last modified: 2014-06-07 16:19:15 UTC

Wikimedia Bugzilla is closed!

Wikimedia has migrated from Bugzilla to Phabricator. Bug reports should be created and updated in Wikimedia Phabricator instead. Please create an account in Phabricator and add your Bugzilla email address to it.
Wikimedia Bugzilla is read-only. If you try to edit or create any bug report in Bugzilla you will be shown an intentional error message.
In order to access the Phabricator task corresponding to a Bugzilla report, just remove "static-" from its URL.
You could still run searches in Bugzilla or access your list of votes but bug reports will obviously not be up-to-date in Bugzilla.
Bug 19761 - Remove worse-than-useless <meta> keywords feature
Remove worse-than-useless <meta> keywords feature
Status: CLOSED FIXED
Product: MediaWiki
Classification: Unclassified
Parser (Other open bugs)
unspecified
All All
: Normal minor (vote)
: ---
Assigned To: Brion Vibber
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2009-07-16 03:30 UTC by Laurence 'GreenReaper' Parry
Modified: 2014-06-07 16:19 UTC (History)
5 users (show)

See Also:
Web browser: ---
Mobile Platform: ---
Assignee Huggle Beta Tester: ---


Attachments

Description Laurence 'GreenReaper' Parry 2009-07-16 03:30:56 UTC
The feature that adds meta keywords to the header of each page implementation of this feature is insufficient, and the very concept of selected keywords is ultimately flawed. It should be removed.

The idea of meta keywords was to provide search engines. From HTML 4.01 (http://www.w3.org/TR/REC-html40/struct/global.html#h-7.4.4.2):
A common use for META is to specify keywords that a search engine may use to improve the quality of search results.
(http://www.w3.org/TR/REC-html40/appendix/notes.html#recs):
"Some indexing engines look for META elements that define a comma-separated list of keywords/phrases ... Search engines may present these keywords as the result of a search."

So what's wrong? To start with, MediaWiki's implementation of this feature is worse than useless. If we are to believe it, the most relevant terms for Wikipedia's main page are:
"Main Page,1769,1945,1994,1999,2.5D,2004,2009,2D computer graphics,622,Aiea, Hawaii"

For the current featured article, they are:
"Domitian,Articles with unsourced statements from July 2009,Flavian Dynasty,The Triumph of Titus Alma Tadema.jpg,Special:Search/Domitian,69,79,81,96,Abdication,Abortion"

The theory is that these topics are important because they are either within the title, or linked in the article. This misses the point, as search engines _already look_ for text that is in the title or linked in the article.

As shown above, the algorithm fails spectacularly to select sensible keywords. These keywords would do more harm than good if they did anything. Fortunately, they do not. Modern search engines do not use these keywords because of their propensity for spam/SEO (see http://en.wikipedia.org/wiki/Keyword_stuffing). They simply cannot be relied on.

Google went out of its way to talk about every other meta tag, then denied using keywords when asked:
http://googlewebmastercentral.blogspot.com/2007/12/answering-more-popular-picks-meta-tags.html
(John Mueller: 'You're right in that we generally ignore the contents of the "keywords" meta tag.')

Unfortunately, the 80-100 gzipped bytes (250-350 uncompressed bytes) these keywords occupy per response still negatively impacts users. Coming as they do before other headers, the keywords delay the load of linked CSS and JS files, as well as the content itself, occupy cache space, and take CPU to generate.

Providing a way to specify appropriate keywords is not a solution, as it would distract attention from actually useful editing. The standard itself has been abandoned by those intended to use it. This feature should be removed altogether, or at the very least made optional and turned off by default.

(Ironically, the meta keyword that *is* sometimes used - "description" - is not supported by MediaWiki, probably because search engines do a good enough job at figuring out appropriate text without it.)
Comment 1 Laurence 'GreenReaper' Parry 2009-07-16 03:32:47 UTC
Whoops - please read the first paragraph to "The implementation of the feature that adds meta keywords to the header of each page is insufficient, and the very concept of selected keywords is ultimately flawed. It should be removed." :-)
Comment 2 Chad H. 2009-07-16 14:34:03 UTC
Cf bug 570 and bug 7614. Can probably be marked INVALID/WONTFIX if this bug is done.
Comment 3 Brion Vibber 2009-07-19 17:00:51 UTC
Could have sworn I removed this misfeature a year or two ago. :) Gettin' out the scissors...
Comment 4 Brion Vibber 2009-07-19 17:07:52 UTC
Done in r53482.

Note the functionality could be replicated in an extension easily enough should someone actually want such things. :) But modern search engines don't use the field, and the values were poorly selected, so I'm happy to kill it.
Comment 5 Dan Jacobson 2009-07-20 23:02:00 UTC
(In reply to comment #0)
> Unfortunately, the 80-100 gzipped bytes (250-350 uncompressed bytes) these
> keywords occupy per response still negatively impacts users. Coming as they do
> before other headers, the keywords delay the load of linked CSS and JS files,
> as well as the content itself, occupy cache space, and take CPU to generate.
How about accessibility bug 19453: it's as if your keyword bad dream
jumped out of the <head> and into a rendered nightmare the top of the <body>
for several screenfulls, doubling total page bytes too.
Comment 6 Paul Zimmerman 2010-12-10 01:01:03 UTC
Aargh! Our mediawiki implementation requires a few specific meta tags to work with our company's search system, and with 1.16 it's all broken... it worked great previously. The metakeywordstag extension no longer works, and the metatag extension requires protected pages which does not support our collaborative environment. Any suggestions on a work-around?
Comment 7 Ilmari Karonen 2010-12-10 02:33:34 UTC
As Brion notes, turning the code he removed into a hook should be trivial.  In fact, here it is: [[mw:User:Ilmari_Karonen/MetaKeywords]].  Stick that in a .php file somewhere, require_once() it from LocalSettings.php and you should be fine.

Note: I haven't actually tested the code, besides running php -l on it.  If you find a bug, let me know.
Comment 8 Ilmari Karonen 2010-12-10 02:34:23 UTC
Pfft... stupid fake wikilink syntax.  Here it is:

http://www.mediawiki.org/wiki/User:Ilmari_Karonen/MetaKeywords
Comment 9 Paul Zimmerman 2010-12-10 02:40:09 UTC
Sweet... thanks a ton!!
Comment 10 Nemo 2014-06-07 16:19:15 UTC
I noticed around 2009 or so that the keywords were less useful for Wikiquote than for Wikipedia. 5 years later I went to check if that was still the case and I discovered this bug. :)

Anyway, it seems "keywords" is basically replaced by "description" now (bug 12196) and I think there is a remote chance of this happening in an extension instead: bug 66325.

Note You need to log in before you can comment on or make changes to this bug.


Navigation
Links